"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const codemirror_1 = require("@jupyterlab/codemirror");
const mql_linter_1 = require("./mql-linter");
require("./mql-syntax-highlighter");
require("./jsmql-linter");
const plugin = {
    id: "@mavenomics/mql-tooling:plugin",
    autoStart: true,
    activate: (app) => {
        // TODO: Hook MQL helpers into some CodeMirror service
        // Also setup GoToDef where available
        codemirror_1.CodeMirrorEditor.addCommand("gotodef-mql", async (cm) => {
            if (!app.commands.hasCommand("@mavenomics/help:go-to-doc")) {
                return; // No help browser on this deployment
            }
            const funcs = await mql_linter_1.getAvailableFunctions();
            const cur = cm.getDoc().getCursor();
            let token = cm.getTokenAt(cur);
            if (funcs.findIndex(i => i.name === token.string) === -1) {
                // either not an MQL function, or not a valid one
                return;
            }
            app.commands.execute("@mavenomics/help:go-to-doc", { docPath: `/Reference/MQL/${token.string}` });
        });
    }
};
exports.default = plugin;
